//+------------------------------------------------------------------+
//|                                            Golden_section_v2.mq4 |
//|                                                            Talex |
//|                                                 tan@gazinter.net |
//+------------------------------------------------------------------+
#property copyright "Talex"
#property link      "tan@gazinter.net"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Lime

extern int ExtDepth=8; /*   ZZ */
/*extern*/ int ExtIndicator=0; /*  ,       ,   0 */
extern double ExtDopusk=0.01; /*         ExtDopusk */
extern int ExtPoint=3; /*    ,    3,        */
extern int ExtMovePoint=0; /*           */
extern bool ExtPitchfork=true; /*      */
extern int ExtPitchforkFanLevel=1; /* 1- ()  ,   ,  2,     ..,      */ 
extern bool ExtBack=true; /*  true,        */
extern bool ExtFan=true; /*  true,       */
extern bool ExtRec=true; /*  true,       */
extern bool ExtArc=true; /*  true,       */
extern bool ExtChannel=false; /*  true,        */
extern double ExtLeftChannel=1.618; /*       */
extern double ExtRightChannel=1.618; /*       */
extern bool ExtSave=false; /*  true,       */
extern double ExtScale=1; /*    */
extern int ExtFanStyle=0; /*     */
extern int ExtFanWidth=1; /*     */
extern color ExtFanColor=DeepPink; /*   */
extern int ExtRecStyle=4; /*     */
extern int ExtRecWidth=1; /*     */
extern color ExtRecColor=Yellow; /*   */
extern int ExtArcStyle=0; /*     */ 
extern int ExtArcWidth=1; /*     */
extern color ExtArcColor=Red; /*   */
extern int ExtChannelStyle=0; /*     */ 
extern int ExtChannelWidth=1; /*     */ 
extern color ExtChannelColor=Blue; /*    */
extern int ExtPitchforkStyle=0; /*     */
extern int ExtPitchforkWidth=1; /*     */
extern color ExtPitchforkColor=Lime; /*   */
/*       */
extern double PricePointX=0; /*   X */
extern double PricePointA=0; /*   A */
extern double PricePointB=0; /*   B */
extern datetime TimePointX=0; /*   X   '1980.07.19 12:30' */
extern datetime TimePointA=0; /*   A   '1980.07.19 12:30' */
extern datetime TimePointB=0; /*   B   '1980.07.19 12:30' */

/*  -    , ,         extern */

double zz[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(1);
   SetIndexBuffer(0,zz);
   SetIndexStyle(0,DRAW_SECTION);
   SetIndexEmptyValue(0,0.0);
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   int i;
   
    for(i=0;i<=Bars-1;i++)
    {
    ObjectDelete("FiboFan1"+"_"+i);
    ObjectDelete("FiboFan2"+"_"+i);
    ObjectDelete("FiboArc"+"_"+i);
    ObjectDelete("Rectangle"+"_"+i);
    ObjectDelete("LeftChannel"+"_"+i);
    ObjectDelete("RightChannel"+"_"+i);
    ObjectDelete("LeftLine"+"_"+i);
    ObjectDelete("RightLine"+"_"+i);
    ObjectDelete("Pitchfork"+"_"+i);
    ObjectDelete("Mediana"+"_"+i);
    }
    
   //----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int PP[];
   int i,j,X,A,B;
   double R0382=0.382, R0786=0.786, retXB, minret, maxret;
   double p1,p2,p3,p4,p5,p6,p7;
   datetime t1,t2,t3,t4,t5,t6,t7;
   string save="";
   double tang;
   
   if(ExtSave==true)
   {
    save=TimeToStr(TimeLocal(),TIME_DATE|TIME_SECONDS);
   }
   minret=1-ExtDopusk; maxret=1+ExtDopusk;
   
   ArrayResize(PP,ExtPoint); 
   
   if(PricePointX!=0 && PricePointA!=0 && PricePointB!=0 && TimePointX!=0 && TimePointA!=0 && TimePointB!=0)
   {
    PP[0]=iBarShift(NULL,0,TimePointB); zz[PP[0]]=PricePointB;
    PP[1]=iBarShift(NULL,0,TimePointA); zz[PP[1]]=PricePointA;
    PP[2]=iBarShift(NULL,0,TimePointX); zz[PP[2]]=PricePointX;
    ExtPoint=3;
   } else
   {
   switch (ExtIndicator)
     {
      case 0: {ZZTalex(ExtDepth);   break;}
      /*         */
      default:{ZZTalex(ExtDepth);   break;}
     }
     if(ExtIndicator==0)
     { 
      j=0;
      for(i=0;i<Bars-1 && j<=ExtPoint;i++)
      {
       if(zz[i]!=0)
       {
        PP[j]=i;
        j++;
       }
      }
     }
    }
    if(ExtPitchfork==false)
    {
     if((zz[PP[ExtPoint-1]]<zz[PP[ExtPoint-3]] && zz[PP[ExtPoint-3]]<zz[PP[ExtPoint-2]]) || (zz[PP[ExtPoint-1]]>zz[PP[ExtPoint-3]] && zz[PP[ExtPoint-3]]>zz[PP[ExtPoint-2]]))
     {
      retXB=(zz[PP[ExtPoint-2]]-zz[PP[ExtPoint-3]])/(zz[PP[ExtPoint-2]]-zz[PP[ExtPoint-1]]+0.000001);
      
      if(retXB>=R0382*minret && retXB<=R0786*maxret)
      {
       t1=Time[PP[ExtPoint-1]];p1=zz[PP[ExtPoint-1]];
       t2=Time[PP[ExtPoint-3]];p2=zz[PP[ExtPoint-3]];
       if(2*PP[ExtPoint-3]-PP[ExtPoint-1]<=0)
       {
        t3=Time[0]-(2*PP[ExtPoint-3]-PP[ExtPoint-1])*Period()*60;p3=zz[PP[ExtPoint-3]]-(zz[PP[ExtPoint-1]]-zz[PP[ExtPoint-3]]);
       } else {t3=Time[2*PP[ExtPoint-3]-PP[ExtPoint-1]];p3=zz[PP[ExtPoint-3]]-(zz[PP[ExtPoint-1]]-zz[PP[ExtPoint-3]]);}
      }
     }
     CreateObject(p1,p2,p3,t1,t2,t3,save);
    }
    if(ExtPitchfork)
   {
    t1=Time[PP[ExtPoint-1]];p1=zz[PP[ExtPoint-1]];
    t2=Time[PP[ExtPoint-2]];p2=zz[PP[ExtPoint-2]];
    t3=Time[PP[ExtPoint-3]];p3=zz[PP[ExtPoint-3]];
    p4=(zz[PP[ExtPoint-2]]+zz[PP[ExtPoint-3]])/2;
    ObjectCreate("Pitchfork"+"_"+save+ExtDepth,OBJ_PITCHFORK,0,t1,p1,t2,p2,t3,p3);
    ObjectSet("Pitchfork"+"_"+save+ExtDepth,OBJPROP_BACK,ExtBack);
    ObjectSet("Pitchfork"+"_"+save+ExtDepth,OBJPROP_COLOR,ExtPitchforkColor);
    ObjectSet("Pitchfork"+"_"+save+ExtDepth,OBJPROP_STYLE,ExtPitchforkStyle);
    ObjectSet("Pitchfork"+"_"+save+ExtDepth,OBJPROP_WIDTH,ExtPitchforkWidth);
       
    tang=(p1-p4)/(PP[ExtPoint-1]-(PP[ExtPoint-2]-(PP[ExtPoint-2]-PP[ExtPoint-3])/2.0));
    t5=t3;
    p5=p1-tang*(PP[ExtPoint-1]-PP[ExtPoint-3]);
    ObjectCreate("Mediana"+"_"+save+ExtDepth,OBJ_TREND,0,t1,p1,t5,p5);
    ObjectSet("Mediana"+"_"+save+ExtDepth,OBJPROP_BACK,ExtBack);
    ObjectSet("Mediana"+"_"+save+ExtDepth,OBJPROP_COLOR,ExtPitchforkColor);
    
    if(ExtPitchforkFanLevel>3 || ExtPitchforkFanLevel<1)ExtPitchforkFanLevel=3;
     
     if((p1<p2 && p1<p4) || (p1>p2 && p1>p4))
     {
      /*       100% */
      if(ExtPitchforkFanLevel==3)
      {
       p6=(p5-p3)/0.382+p3;//-tang*ExtMovePoint;
       if(ObjectGetShiftByValue("Mediana"+"_"+save+ExtDepth,p6)<-100)
        {
         Alert(" 3      ,    2.");
         ExtPitchforkFanLevel=2;
        }
      }
      if(ExtPitchforkFanLevel==2)
      {
       p6=(p5-p3)/0.5+p3;//-tang*ExtMovePoint;
       if(ObjectGetShiftByValue("Mediana"+"_"+save+ExtDepth,p6)<-100)
        {
         Alert(" 2      ,    1.");
         ExtPitchforkFanLevel=1;
        }
       } 
       if(ExtPitchforkFanLevel==1)
      {
       p6=(p5-p3)/0.618+p3;//-tang*ExtMovePoint;
       if(ObjectGetShiftByValue("Mediana"+"_"+save+ExtDepth,p6)<-100)
        {
         Alert(" 1      ,   .");
         return(0);
        }
       } 
       if(ObjectGetShiftByValue("Mediana"+"_"+save+ExtDepth,p6)>0)
       {
        t6=Time[ObjectGetShiftByValue("Mediana"+"_"+save+ExtDepth,p6)]+ExtMovePoint*Period()*60;
       } else t6=Time[0]-ObjectGetShiftByValue("Mediana"+"_"+save+ExtDepth,p6)*Period()*60+ExtMovePoint*Period()*60;
     }
     if((p1<p2 && p1>p4) || (p1>p2 && p1<p4))
     {
      /*       100% */
      if(ExtPitchforkFanLevel==3)
      {
       p6=(p5-p3)/2.618+p3;//-tang*ExtMovePoint;
       if(ObjectGetShiftByValue("Mediana"+"_"+save+ExtDepth,p6)<-100)
        {
         Alert(" 3      ,    2.");
         ExtPitchforkFanLevel=2;
        }
      }
      if(ExtPitchforkFanLevel==2)
      {
       p6=(p5-p3)/1.618+p3;//-tang*ExtMovePoint;
       if(ObjectGetShiftByValue("Mediana"+"_"+save+ExtDepth,p6)<-100)
        {
         Alert(" 2      ,    1.");
         ExtPitchforkFanLevel=1;
        }
       } 
       if(ExtPitchforkFanLevel==1)
      {
       p6=(p5-p3)/1.272+p3;//-tang*ExtMovePoint;
       if(ObjectGetShiftByValue("Mediana"+"_"+save+ExtDepth,p6)<-100)
        {
         Alert(" 1      ,   .");
         return(0);
        }
       } 
       if(ObjectGetShiftByValue("Mediana"+"_"+save+ExtDepth,p6)>0)
       {
        t6=Time[ObjectGetShiftByValue("Mediana"+"_"+save+ExtDepth,p6)]+ExtMovePoint*Period()*60;
       } else t6=Time[0]-ObjectGetShiftByValue("Mediana"+"_"+save+ExtDepth,p6)*Period()*60+ExtMovePoint*Period()*60;
     }
     if(ObjectGetShiftByValue("Mediana"+"_"+save+ExtDepth,p6)>0)
     {
      t7=Time[2*ObjectGetShiftByValue("Mediana"+"_"+save+ExtDepth,p6)-PP[ExtPoint-3]]+ExtMovePoint*Period()*60;
     }
      else t7=t6+(PP[ExtPoint-3]-ObjectGetShiftByValue("Mediana"+"_"+save+ExtDepth,p6))*Period()*60+ExtMovePoint*Period()*60;
     p7=2*p6-p3;
     //Print("t6=",TimeToStr(t6,TIME_DATE),"; p6=",p6,"; NbarMediana=",ObjectGetShiftByValue("Mediana"+"_"+save+ExtDepth,p6));
     //Print("t3=",TimeToStr(t3,TIME_DATE),"; p3=",p3,"; t7=",TimeToStr(t7,TIME_DATE),"; p7=",p7);
    CreateObject(p3,p6,p7,t3,t6,t7,save);
     
   }
   
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+

/*------------------------------------------------------------------+
|  ZigZag_Talex,     .     |
|     ExtPoint.                            |
+------------------------------------------------------------------*/
void ZZTalex(int n)
{
/**/
   int    i,j,k,zzbarlow,zzbarhigh,curbar,curbar1,curbar2,EP,Mbar[];
   double curpr,Mprice[];
   bool flag,fd;
   static int endbar;
   static double endpr;
   
   
   /**/
   
   for(i=0;i<=Bars-1;i++)
   {zz[i]=0.0;}
   
   EP=ExtPoint;
   zzbarlow=iLowest(NULL,0,MODE_LOW,n,0);        
   zzbarhigh=iHighest(NULL,0,MODE_HIGH,n,0);     
   
   if(zzbarlow<zzbarhigh) {curbar=zzbarlow; curpr=Low[zzbarlow];}
   if(zzbarlow>zzbarhigh) {curbar=zzbarhigh; curpr=High[zzbarhigh];}
   if(zzbarlow==zzbarhigh){curbar=zzbarlow;curpr=funk1(zzbarlow, n);}
   
   ArrayResize(Mbar,ExtPoint);
   ArrayResize(Mprice,ExtPoint);
   j=0;
   endpr=curpr;
   endbar=curbar;
   Mbar[j]=curbar;
   Mprice[j]=curpr;
   
   EP--;
   if(curpr==Low[curbar]) flag=true;
   else flag=false;
    
   i=curbar+1;
   while(EP>0)
   {
    if(flag)
    {
     while(i<=Bars-1)
     {
     curbar1=iHighest(NULL,0,MODE_HIGH,n,i); 
     curbar2=iHighest(NULL,0,MODE_HIGH,n,curbar1); 
     if(curbar1==curbar2){curbar=curbar1;curpr=High[curbar];flag=false;i=curbar+1;j++;break;}
     else i=curbar2;
     }
     
     Mbar[j]=curbar;
     Mprice[j]=curpr;
     EP--;
     
    }
    
    if(EP==0) break;
    
    if(!flag) 
    {
     while(i<=Bars-1)
     {
     curbar1=iLowest(NULL,0,MODE_LOW,n,i); 
     curbar2=iLowest(NULL,0,MODE_LOW,n,curbar1); 
     if(curbar1==curbar2){curbar=curbar1;curpr=Low[curbar];flag=true;i=curbar+1;j++;break;}
     else i=curbar2;
     }
     
     Mbar[j]=curbar;
     Mprice[j]=curpr;
     EP--;
    }
   }
   /*   */
   if(Mprice[0]==Low[Mbar[0]])fd=true; else fd=false;
   for(k=0;k<=ExtPoint-1;k++)
   {
    if(k==0)
    {
     if(fd==true)
      {
       Mbar[k]=iLowest(NULL,0,MODE_LOW,Mbar[k+1]-Mbar[k],Mbar[k]);Mprice[k]=Low[Mbar[k]];endbar=ExtDepth;
      }
     if(fd==false)
      {
       Mbar[k]=iHighest(NULL,0,MODE_HIGH,Mbar[k+1]-Mbar[k],Mbar[k]);Mprice[k]=High[Mbar[k]];endbar=ExtDepth;
      }
    }
    if(k<ExtPoint-2)
    {
     if(fd==true)
      {
       Mbar[k+1]=iHighest(NULL,0,MODE_HIGH,Mbar[k+2]-Mbar[k]-1,Mbar[k]+1);Mprice[k+1]=High[Mbar[k+1]];
      }
     if(fd==false)
      {
       Mbar[k+1]=iLowest(NULL,0,MODE_LOW,Mbar[k+2]-Mbar[k]-1,Mbar[k]+1);Mprice[k+1]=Low[Mbar[k+1]];
      }
    }
    if(fd==true)fd=false;else fd=true;
    
    /*  ZigZag'a */
    zz[Mbar[k]]=Mprice[k];
    //Print("zz_"+k,"=",zz[Mbar[k]]);
   }
  
 } 
/*-------------------------------------------------------------------+
/  ZigZag_Talex                                                 |
/-------------------------------------------------------------------*/

/*-------------------------------------------------------------------+
/       (  )   |
/     .                             |
/-------------------------------------------------------------------*/
double funk1(int zzbarlow, int ExtDepth)
{
 double pr;
 int fbarlow,fbarhigh;
 
 fbarlow=iLowest(NULL,0,MODE_LOW,ExtDepth,zzbarlow);  
 fbarhigh=iHighest(NULL,0,MODE_HIGH,ExtDepth,zzbarlow);
 
 if(fbarlow>fbarhigh) {/*if((Low[zzbarlow]<Low[fbarhigh]) && (High[zzbarlow]<High[fbarhigh]))*/ pr=Low[zzbarlow];}
 if(fbarlow<fbarhigh) {/*if((Low[zzbarlow]>Low[fbarlow]) && (High[zzbarlow]>High[fbarlow]))*/ pr=High[zzbarlow];}
 if(fbarlow==fbarhigh)
 {
  fbarlow=iLowest(NULL,0,MODE_LOW,2*ExtDepth,zzbarlow);  
  fbarhigh=iHighest(NULL,0,MODE_HIGH,2*ExtDepth,zzbarlow);
  if(fbarlow>fbarhigh) {/*if((Low[zzbarlow]<Low[fbarhigh]) && (High[zzbarlow]<High[fbarhigh]))*/ pr=Low[zzbarlow];}
  if(fbarlow<fbarhigh) {/*if((Low[zzbarlow]>Low[fbarlow]) && (High[zzbarlow]>High[fbarlow]))*/ pr=High[zzbarlow];}
  if(fbarlow==fbarhigh)
  {
   fbarlow=iLowest(NULL,0,MODE_LOW,3*ExtDepth,zzbarlow);  
   fbarhigh=iHighest(NULL,0,MODE_HIGH,3*ExtDepth,zzbarlow);
   if(fbarlow>fbarhigh) {/*if((Low[zzbarlow]<Low[fbarhigh]) && (High[zzbarlow]<High[fbarhigh]))*/ pr=Low[zzbarlow];}
   if(fbarlow<fbarhigh) {/*if((Low[zzbarlow]>Low[fbarlow]) && (High[zzbarlow]>High[fbarlow]))*/ pr=High[zzbarlow];}
  }
 }
 return(pr);
}
/*----------------------------------------------------------------------------*/

/*------------------------------------------------------------------+
|                                            |
+------------------------------------------------------------------*/
void CreateObject(double p1, double p2, double p3, datetime t1, datetime t2, datetime t3,string save)
{
 if(ExtFan)
       { 
       ObjectCreate("FiboFan1"+"_"+save+ExtDepth,OBJ_FIBOFAN,0,t2,p2,t1,p1);
       ObjectSet("FiboFan1"+"_"+save+ExtDepth,OBJPROP_BACK,ExtBack);
       ObjectSet("FiboFan1"+"_"+save+ExtDepth,OBJPROP_FIBOLEVELS,11);
       ObjectSet("FiboFan1"+"_"+save+ExtDepth,OBJPROP_LEVELCOLOR,ExtFanColor);
       ObjectSet("FiboFan1"+"_"+save+ExtDepth,OBJPROP_LEVELSTYLE,ExtFanStyle);
       ObjectSet("FiboFan1"+"_"+save+ExtDepth,OBJPROP_LEVELWIDTH,ExtFanWidth);
       ObjectSet("FiboFan1"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+0,0);
       ObjectSet("FiboFan1"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+1,0.382);
       ObjectSet("FiboFan1"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+2,0.50);
       ObjectSet("FiboFan1"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+3,0.618);
       ObjectSet("FiboFan1"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+4,0.786);
       ObjectSet("FiboFan1"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+5,0.886);
       ObjectSet("FiboFan1"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+6,1);
       ObjectSet("FiboFan1"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+7,1.272);
       ObjectSet("FiboFan1"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+8,1.618);
       ObjectSet("FiboFan1"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+9,2);
       ObjectSet("FiboFan1"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+10,2.618);
       ObjectSetFiboDescription("FiboFan1"+"_"+save+ExtDepth,0,"0");
       ObjectSetFiboDescription("FiboFan1"+"_"+save+ExtDepth,1,"38.2");
       ObjectSetFiboDescription("FiboFan1"+"_"+save+ExtDepth,2,"50");
       ObjectSetFiboDescription("FiboFan1"+"_"+save+ExtDepth,3,"61.8");
       ObjectSetFiboDescription("FiboFan1"+"_"+save+ExtDepth,4,"78.6");
       ObjectSetFiboDescription("FiboFan1"+"_"+save+ExtDepth,5,"88.6");
       ObjectSetFiboDescription("FiboFan1"+"_"+save+ExtDepth,6,"100");
       ObjectSetFiboDescription("FiboFan1"+"_"+save+ExtDepth,7,"127.2");
       ObjectSetFiboDescription("FiboFan1"+"_"+save+ExtDepth,8,"161.8");
       ObjectSetFiboDescription("FiboFan1"+"_"+save+ExtDepth,9,"200");
       ObjectSetFiboDescription("FiboFan1"+"_"+save+ExtDepth,10,"261.8");
       ObjectCreate("FiboFan2"+"_"+save+ExtDepth,OBJ_FIBOFAN,0,t2,p2,t3,p3);
       ObjectSet("FiboFan2"+"_"+save+ExtDepth,OBJPROP_BACK,ExtBack);
       ObjectSet("FiboFan2"+"_"+save+ExtDepth,OBJPROP_FIBOLEVELS,11);
       ObjectSet("FiboFan2"+"_"+save+ExtDepth,OBJPROP_LEVELCOLOR,ExtFanColor);
       ObjectSet("FiboFan2"+"_"+save+ExtDepth,OBJPROP_LEVELSTYLE,ExtFanStyle);
       ObjectSet("FiboFan2"+"_"+save+ExtDepth,OBJPROP_LEVELWIDTH,ExtFanWidth);
       ObjectSet("FiboFan2"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+0,0);
       ObjectSet("FiboFan2"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+1,0.382);
       ObjectSet("FiboFan2"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+2,0.50);
       ObjectSet("FiboFan2"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+3,0.618);
       ObjectSet("FiboFan2"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+4,0.786);
       ObjectSet("FiboFan2"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+5,0.886);
       ObjectSet("FiboFan2"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+6,1);
       ObjectSet("FiboFan2"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+7,1.272);
       ObjectSet("FiboFan2"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+8,1.618);
       ObjectSet("FiboFan2"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+9,2);
       ObjectSet("FiboFan2"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+10,2.618);
       ObjectSetFiboDescription("FiboFan2"+"_"+save+ExtDepth,0,"0");
       ObjectSetFiboDescription("FiboFan2"+"_"+save+ExtDepth,1,"38.2");
       ObjectSetFiboDescription("FiboFan2"+"_"+save+ExtDepth,2,"50");
       ObjectSetFiboDescription("FiboFan2"+"_"+save+ExtDepth,3,"61.8");
       ObjectSetFiboDescription("FiboFan2"+"_"+save+ExtDepth,4,"78.6");
       ObjectSetFiboDescription("FiboFan2"+"_"+save+ExtDepth,5,"88.6");
       ObjectSetFiboDescription("FiboFan2"+"_"+save+ExtDepth,6,"100");
       ObjectSetFiboDescription("FiboFan2"+"_"+save+ExtDepth,7,"127.2");
       ObjectSetFiboDescription("FiboFan2"+"_"+save+ExtDepth,8,"161.8");
       ObjectSetFiboDescription("FiboFan2"+"_"+save+ExtDepth,9,"200");
       ObjectSetFiboDescription("FiboFan2"+"_"+save+ExtDepth,10,"261.8");
       }
       if(ExtRec)
       {
       ObjectCreate("Rectangle"+"_"+save+ExtDepth,OBJ_RECTANGLE,0,t1,p1,t3,p3);
       ObjectSet("Rectangle"+"_"+save+ExtDepth,OBJPROP_BACK,ExtBack);
       ObjectSet("Rectangle"+"_"+save+ExtDepth,OBJPROP_COLOR,ExtRecColor);
       ObjectSet("Rectangle"+"_"+save+ExtDepth,OBJPROP_STYLE,ExtRecStyle);
       ObjectSet("Rectangle"+"_"+save+ExtDepth,OBJPROP_WIDTH,ExtRecWidth);
       ObjectSet("Rectangle"+"_"+save+ExtDepth,OBJPROP_BACK,false);
       }
       if(ExtArc)
       {
       ObjectCreate("FiboArc"+"_"+save+ExtDepth,OBJ_FIBOARC,0,t2,p1,t2,p2);
       ObjectSet("FiboArc"+"_"+save+ExtDepth,OBJPROP_BACK,ExtBack);
       ObjectSet("FiboArc"+"_"+save+ExtDepth,OBJPROP_ELLIPSE,true);
       ObjectSet("FiboArc"+"_"+save+ExtDepth,OBJPROP_SCALE,ExtScale);
       ObjectSet("FiboArc"+"_"+save+ExtDepth,OBJPROP_FIBOLEVELS,11);
       ObjectSet("FiboArc"+"_"+save+ExtDepth,OBJPROP_LEVELCOLOR,ExtArcColor);
       ObjectSet("FiboArc"+"_"+save+ExtDepth,OBJPROP_LEVELSTYLE,ExtArcStyle);
       ObjectSet("FiboArc"+"_"+save+ExtDepth,OBJPROP_LEVELWIDTH,ExtArcWidth);
       ObjectSet("FiboArc"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+0,0);
       ObjectSet("FiboArc"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+1,0.382);
       ObjectSet("FiboArc"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+2,0.50);
       ObjectSet("FiboArc"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+3,0.618);
       ObjectSet("FiboArc"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+4,0.786);
       ObjectSet("FiboArc"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+5,0.886);
       ObjectSet("FiboArc"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+6,1);
       ObjectSet("FiboArc"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+7,1.272);
       ObjectSet("FiboArc"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+8,1.618);
       ObjectSet("FiboArc"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+9,2);
       ObjectSet("FiboArc"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+10,2.618);
       ObjectSetFiboDescription("FiboArc"+"_"+save+ExtDepth,0,"0");
       ObjectSetFiboDescription("FiboArc"+"_"+save+ExtDepth,1,"38.2");
       ObjectSetFiboDescription("FiboArc"+"_"+save+ExtDepth,2,"50");
       ObjectSetFiboDescription("FiboArc"+"_"+save+ExtDepth,3,"61.8");
       ObjectSetFiboDescription("FiboArc"+"_"+save+ExtDepth,4,"78.6");
       ObjectSetFiboDescription("FiboArc"+"_"+save+ExtDepth,5,"88.6");
       ObjectSetFiboDescription("FiboArc"+"_"+save+ExtDepth,6,"100");
       ObjectSetFiboDescription("FiboArc"+"_"+save+ExtDepth,7,"127.2");
       ObjectSetFiboDescription("FiboArc"+"_"+save+ExtDepth,8,"161.8");
       ObjectSetFiboDescription("FiboArc"+"_"+save+ExtDepth,9,"200");
       ObjectSetFiboDescription("FiboArc"+"_"+save+ExtDepth,10,"261.8");
       }
       if(ExtChannel)
       {
        ObjectCreate("LeftLine"+"_"+save+ExtDepth,OBJ_TREND,0,t2,p2,t3,p1+(p2-p1)*(2-ExtLeftChannel));
        ObjectSet("LeftLine"+"_"+save+ExtDepth,OBJPROP_BACK,ExtBack);
        ObjectSet("LeftLine"+"_"+save+ExtDepth,OBJPROP_COLOR,ExtChannelColor);
        ObjectSet("LeftLine"+"_"+save+ExtDepth,OBJPROP_STYLE,ExtChannelStyle);
        ObjectSet("LeftLine"+"_"+save+ExtDepth,OBJPROP_WIDTH,ExtChannelWidth);
        ObjectCreate("LeftChannel"+"_"+save+ExtDepth,OBJ_FIBOCHANNEL,0,t2,p2,t1,p1+(p2-p1)*ExtLeftChannel,t2,p1);
        ObjectSet("LeftChannel"+"_"+save+ExtDepth,OBJPROP_COLOR,ExtChannelColor);
        ObjectSet("LeftChannel"+"_"+save+ExtDepth,OBJPROP_STYLE,ExtChannelStyle);
        ObjectSet("LeftChannel"+"_"+save+ExtDepth,OBJPROP_WIDTH,ExtChannelWidth);
        ObjectSet("LeftChannel"+"_"+save+ExtDepth,OBJPROP_FIBOLEVELS,21);
        ObjectSet("LeftChannel"+"_"+save+ExtDepth,OBJPROP_LEVELCOLOR,ExtChannelColor);
        ObjectSet("LeftChannel"+"_"+save+ExtDepth,OBJPROP_LEVELSTYLE,ExtChannelStyle);
        ObjectSet("LeftChannel"+"_"+save+ExtDepth,OBJPROP_LEVELWIDTH,ExtChannelWidth);
        ObjectSet("LeftChannel"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+0,0);
        ObjectSet("LeftChannel"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+1,0.382);
        ObjectSet("LeftChannel"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+2,0.50);
        ObjectSet("LeftChannel"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+3,0.618);
        ObjectSet("LeftChannel"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+4,0.786);
        ObjectSet("LeftChannel"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+5,0.886);
        ObjectSet("LeftChannel"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+6,1);
        ObjectSet("LeftChannel"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+7,1.272);
        ObjectSet("LeftChannel"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+8,1.618);
        ObjectSet("LeftChannel"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+9,2);
        ObjectSet("LeftChannel"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+10,2.618);
        ObjectSetFiboDescription("LeftChannel"+"_"+save+ExtDepth,0,"0");
        ObjectSetFiboDescription("LeftChannel"+"_"+save+ExtDepth,1,"38.2");
        ObjectSetFiboDescription("LeftChannel"+"_"+save+ExtDepth,2,"50");
        ObjectSetFiboDescription("LeftChannel"+"_"+save+ExtDepth,3,"61.8");
        ObjectSetFiboDescription("LeftChannel"+"_"+save+ExtDepth,4,"78.6");
        ObjectSetFiboDescription("LeftChannel"+"_"+save+ExtDepth,5,"88.6");
        ObjectSetFiboDescription("LeftChannel"+"_"+save+ExtDepth,6,"100");
        ObjectSetFiboDescription("LeftChannel"+"_"+save+ExtDepth,7,"127.2");
        ObjectSetFiboDescription("LeftChannel"+"_"+save+ExtDepth,8,"161.8");
        ObjectSetFiboDescription("LeftChannel"+"_"+save+ExtDepth,9,"200");
        ObjectSetFiboDescription("LeftChannel"+"_"+save+ExtDepth,10,"261.8");
        ObjectSet("LeftChannel"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+11,-0.382);
        ObjectSet("LeftChannel"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+12,-0.50);
        ObjectSet("LeftChannel"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+13,-0.618);
        ObjectSet("LeftChannel"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+14,-0.786);
        ObjectSet("LeftChannel"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+15,-0.886);
        ObjectSet("LeftChannel"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+16,-1);
        ObjectSet("LeftChannel"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+17,-1.272);
        ObjectSet("LeftChannel"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+18,-1.618);
        ObjectSet("LeftChannel"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+19,-2);
        ObjectSet("LeftChannel"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+20,-2.618);
        ObjectSetFiboDescription("LeftChannel"+"_"+save+ExtDepth,11,"-38.2");
        ObjectSetFiboDescription("LeftChannel"+"_"+save+ExtDepth,12,"-50");
        ObjectSetFiboDescription("LeftChannel"+"_"+save+ExtDepth,13,"-61.8");
        ObjectSetFiboDescription("LeftChannel"+"_"+save+ExtDepth,14,"-78.6");
        ObjectSetFiboDescription("LeftChannel"+"_"+save+ExtDepth,15,"-88.6");
        ObjectSetFiboDescription("LeftChannel"+"_"+save+ExtDepth,16,"-100");
        ObjectSetFiboDescription("LeftChannel"+"_"+save+ExtDepth,17,"-127.2");
        ObjectSetFiboDescription("LeftChannel"+"_"+save+ExtDepth,18,"-161.8");
        ObjectSetFiboDescription("LeftChannel"+"_"+save+ExtDepth,19,"-200");
        ObjectSetFiboDescription("LeftChannel"+"_"+save+ExtDepth,20,"-261.8");
        
        ObjectCreate("RightLine"+"_"+save+ExtDepth,OBJ_TREND,0,t2,p2,t1,p1+(p2-p1)*(2-ExtRightChannel));
        ObjectSet("RightLine"+"_"+save+ExtDepth,OBJPROP_BACK,ExtBack);
        ObjectSet("RightLine"+"_"+save+ExtDepth,OBJPROP_COLOR,ExtChannelColor);
        ObjectSet("RightLine"+"_"+save+ExtDepth,OBJPROP_STYLE,ExtChannelStyle);
        ObjectSet("RightLine"+"_"+save+ExtDepth,OBJPROP_WIDTH,ExtChannelWidth);
        ObjectCreate("RightChannel"+"_"+save+ExtDepth,OBJ_FIBOCHANNEL,0,t2,p2,t3,p1+(p2-p1)*ExtRightChannel,t2,p1);
        ObjectSet("RightChannel"+"_"+save+ExtDepth,OBJPROP_COLOR,ExtChannelColor);
        ObjectSet("RightChannel"+"_"+save+ExtDepth,OBJPROP_STYLE,ExtChannelStyle);
        ObjectSet("RightChannel"+"_"+save+ExtDepth,OBJPROP_WIDTH,ExtChannelWidth);
        ObjectSet("RightChannel"+"_"+save+ExtDepth,OBJPROP_FIBOLEVELS,21);
        ObjectSet("RightChannel"+"_"+save+ExtDepth,OBJPROP_LEVELCOLOR,ExtChannelColor);
        ObjectSet("RightChannel"+"_"+save+ExtDepth,OBJPROP_LEVELSTYLE,ExtChannelStyle);
        ObjectSet("RightChannel"+"_"+save+ExtDepth,OBJPROP_LEVELWIDTH,ExtChannelWidth);
        ObjectSet("RightChannel"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+0,0);
        ObjectSet("RightChannel"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+1,0.382);
        ObjectSet("RightChannel"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+2,0.50);
        ObjectSet("RightChannel"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+3,0.618);
        ObjectSet("RightChannel"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+4,0.786);
        ObjectSet("RightChannel"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+5,0.886);
        ObjectSet("RightChannel"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+6,1);
        ObjectSet("RightChannel"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+7,1.272);
        ObjectSet("RightChannel"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+8,1.618);
        ObjectSet("RightChannel"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+9,2);
        ObjectSet("RightChannel"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+10,2.618);
        ObjectSetFiboDescription("RightChannel"+"_"+save+ExtDepth,0,"0");
        ObjectSetFiboDescription("RightChannel"+"_"+save+ExtDepth,1,"38.2");
        ObjectSetFiboDescription("RightChannel"+"_"+save+ExtDepth,2,"50");
        ObjectSetFiboDescription("RightChannel"+"_"+save+ExtDepth,3,"61.8");
        ObjectSetFiboDescription("RightChannel"+"_"+save+ExtDepth,4,"78.6");
        ObjectSetFiboDescription("RightChannel"+"_"+save+ExtDepth,5,"88.6");
        ObjectSetFiboDescription("RightChannel"+"_"+save+ExtDepth,6,"100");
        ObjectSetFiboDescription("RightChannel"+"_"+save+ExtDepth,7,"127.2");
        ObjectSetFiboDescription("RightChannel"+"_"+save+ExtDepth,8,"161.8");
        ObjectSetFiboDescription("RightChannel"+"_"+save+ExtDepth,9,"200");
        ObjectSetFiboDescription("RightChannel"+"_"+save+ExtDepth,10,"261.8");
        ObjectSet("RightChannel"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+11,-0.382);
        ObjectSet("RightChannel"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+12,-0.50);
        ObjectSet("RightChannel"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+13,-0.618);
        ObjectSet("RightChannel"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+14,-0.786);
        ObjectSet("RightChannel"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+15,-0.886);
        ObjectSet("RightChannel"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+16,-1);
        ObjectSet("RightChannel"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+17,-1.272);
        ObjectSet("RightChannel"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+18,-1.618);
        ObjectSet("RightChannel"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+19,-2);
        ObjectSet("RightChannel"+"_"+save+ExtDepth,OBJPROP_FIRSTLEVEL+20,-2.618);
        ObjectSetFiboDescription("RightChannel"+"_"+save+ExtDepth,11,"-38.2");
        ObjectSetFiboDescription("RightChannel"+"_"+save+ExtDepth,12,"-50");
        ObjectSetFiboDescription("RightChannel"+"_"+save+ExtDepth,13,"-61.8");
        ObjectSetFiboDescription("RightChannel"+"_"+save+ExtDepth,14,"-78.6");
        ObjectSetFiboDescription("RightChannel"+"_"+save+ExtDepth,15,"-88.6");
        ObjectSetFiboDescription("RightChannel"+"_"+save+ExtDepth,16,"-100");
        ObjectSetFiboDescription("RightChannel"+"_"+save+ExtDepth,17,"-127.2");
        ObjectSetFiboDescription("RightChannel"+"_"+save+ExtDepth,18,"-161.8");
        ObjectSetFiboDescription("RightChannel"+"_"+save+ExtDepth,19,"-200");
        ObjectSetFiboDescription("RightChannel"+"_"+save+ExtDepth,20,"-261.8");
       }
}